# 使用 PIP 在 python 中安装包

> 原文： [https://thepythonguru.com/installing-packages-in-python-using-pip](https://thepythonguru.com/installing-packages-in-python-using-pip)

* * *

于 2020 年 1 月 7 日更新

* * *

PIP 是一个包管理系统，用于从存储库安装包。 您可以使用`pip`安装 [http://pypi.python.org/pypi](http://pypi.python.org/pypi) 上可用的各种包。 PIP 与 php 中的作曲家非常相似。 PIP 是递归的首字母缩写，代表 PIP 安装包。

## 安装 PIP

* * *

Python 2.7.9 及更高版本（python2 系列）和 Python 3.4 及更高版本（python 3 系列）已经带有 pip。

要检查您的 python 版本，您需要输入以下命令：

```py
python  -V

```

如果您的 python 版本不属于上述任何版本，则需要手动安装`pip`（请参见下面的链接）。

*   [单击此处以获取 Windows 安装说明](http://stackoverflow.com/questions/4750806/how-to-install-pip-on-windows)。
*   [单击此处以获取 Linux 指南](https://pip.pypa.io/en/latest/installing.html)。

## 安装包

* * *

假设您要安装一个名为 [Requests](https://pypi.python.org/pypi/requests/2.7.0) 的包（用于发出 HTTP 请求）。 您需要发出以下命令。

```py
pip install requests # this will install latest request package
pip install requests==2.6.0 # this will install requests 2.6.0 package not the latest package
pip install requests>=2.6.0 # specify a minimum version if it's not available pip will install the latest version

```

**注意**：

`pip.exe`存储在`C:\Python34\Scripts`下，因此您需要去那里安装包。 或者，将整个路径添加到`PATH`环境变量。 这样，您可以从任何目录访问`pip`。

## 卸载包

* * *

要卸载包，请使用以下命令。

```py
pip uninstall package_name

```

## 升级包

* * *

```py
pip install --upgrade package_name

```

## 搜索包

* * *

```py
pip search "your query"

```

**注意**：

您无需在搜索字词前后添加引号。

## 列出已安装的包

* * *

```py
pip list

```

上面的命令将列出所有已安装的包。

## 列出过时的已安装包

* * *

```py
pip list --outdated

```

## 有关已安装包的详细信息

* * *

您可以使用以下命令来获取有关已安装包的信息，即包名称，版本，位置，依赖项。

```py
pip show package_name

```

* * *

* * *