# python 入门

> 原文： [https://thepythonguru.com/getting-started-with-python/](https://thepythonguru.com/getting-started-with-python/)

* * *

于 2020 年 1 月 7 日更新

* * *

## 什么是 Python？

* * *

Python 是 Guido Van Rossum 创建的通用编程语言。 如果您刚刚开始编程生涯，Python 因其优雅的语法和可读代码而广受赞誉。Python 最适合您。 使用 Python，您可以完成 GUI 开发，Web 应用，系统管理任务，财务计算，数据分析，可视化以及列表等所有工作。

## Python 是一种解释语言

* * *

是的，Python 是解释语言，当您运行 python 程序时，解释器将逐行解析 python 程序，而 C 或 C++ 等已编译的语言则先编译该程序然后开始运行。

现在您可能会问，那有什么区别？

区别在于，与编译语言相比，解释语言要慢一些。 是的，如果使用 C 或 C++ 等编译语言编写代码，则绝对会获得一些性能上的好处。

但是用这种语言编写代码对于初学者来说是艰巨的任务。 同样在这种语言中，您甚至需要编写大多数基本功能，例如计算数组的长度，分割字符串等。对于更高级的任务，有时您需要创建自己的数据结构以将数据封装在程序中。 因此，在 C/C++ 中，在真正开始解决业务问题之前，您需要注意所有次要细节。 这就是 Python 来的地方。 在 Python 中，您不需要定义任何数据结构，也不需要定义小型工具函数，因为 Python 可以帮助您入门。

此外，Python 在 [https://pypi.python.org/](https://pypi.python.org/) 上提供了数百个可用的库，您可以在项目中使用它们而无需重新设计轮子。

## Python 是动态类型的

* * *

Python 不需要您提前定义变量数据类型。 Python 根据其包含的值的类型自动推断变量的数据类型。

例如：

```py
myvar = "Hello Python"

```

上面的代码行将字符串`"Hello Python"`分配给变量`myvar`，因此`myvar`的类型为字符串。

请注意，与 C，C++ 和 Java 之类的语言不同，在 Python 中，您不需要以分号（`;`）结尾的语句。

假设稍后在程序中我们为变量`myvar`分配了`1`的值，即

```py
myvar = 1

```

现在`myvar`变量的类型为`int`。

## Python 是强类型的

* * *

如果您使用 PHP 或 javascript 编程。 您可能已经注意到，它们都将一种类型的数据自动转换为另一种类型。

For e.g:

在 JavaScript 中

```py
1 + "2"

```

将是`'12'`

在这里，在进行加法（`+`）之前，`1`将转换为字符串并连接到`"2"`，这将导致`'12'`成为字符串。 但是，在 Python 中，不允许进行此类自动转换，因此

```py
1 + "2"

```

会产生一个错误。

试试看：

```py
# run this code to see the error
1 + "2" 
```

## 编写更少的代码，做更多的事情

* * *

用 Python 编写的程序通常是 Java 代码的 1/3 或 1/5。 这意味着我们可以用 Python 编写更少的代码来实现与 Java 相同的功能。

要在 Python 中读取文件，您只需要两行代码：

```py
with open("myfile.txt") as f:
   print(f.read())

```

试一试：

```py
# these two lines create a file "myfile.txt" with data "Learning Python"
with open("myfile.txt", "w") as f:
   f.write("Learning Python")

# these two lines read data from myfile.txt
with open("myfile.txt") as f:
   print(f.read()) 
```

不要太在意用于读写文件的命令。 我们将在以后的文章中学习所有内容。

## 谁使用 Python

* * *

许多大型组织（例如 Google，NASA，Quora，HortonWorks 等）都使用 Python。

好的，我可以开始用 Python 构建什么？

您想要的几乎任何东西。 例如：

*   GUI 应用
*   网络应用
*   从网站抓取数据
*   分析数据
*   系统管理工具
*   游戏开发
*   数据科学

还有很多 ...

在下一篇文章中，我们将学习[如何安装 Python](/installing-python3/) 。

* * *

* * *